# Renku Knowledge Graph Explorer

Test out the Renku Knowledge Graph Explorer [here](http://lkksdsc.pythonanywhere.com)!

<img src="https://renkulab.io/gitlab/laura.kinkead/knowledge-graph-dashboard/-/raw/master/renku_kg_explorer.png"  width="900">


## About
Renku is a knowledge infrastructure that accompanies a data scientist throughout all stages of the research lifecycle.
At its core, the Renku Knowledge graph links versioned digital objects within - and across! - collaborative projects.
With the Renku Knowlege Graph Explorer, discover how Renku projects around the world are connected via the shared use of the same datasets!

This web app is built using [Plotly Dash](https://dash.plotly.com), and the graph visualization is powered by [Cytoscape](https://dash.plotly.com/cytoscape).

## Usage
### Live Test
The app is hosted live on [PythonAnywhere](http://lkksdsc.pythonanywhere.com)- go and give it a whirl!

### Install
If you'd like to install the dashboard on locally, follow these steps (preferably in a fresh Python 3.9 conda or venv environment):
```
git clone git@renkulab.io:laura.kinkead/knowledge-graph-dashboard.git
cd knowledge-graph-dashboard
pip install -r requirements.txt
python src/dash_app.py
```

### Deploy
Want to deploy this project on PythonAnywhere yourself? Here's how to do it:
* Make an account on [PythonAnywhere.com](http://pythonanywhere.com)
* Follow PythonAnywhere's excellent WebApp tutorial, including:
    * Clone the repo. Note that depending on your repository permissions, you may also need to create a new ssh keypair and upload it to GitLab.
    * Follow the PythonAnywhere's tutorial to create a virtual environment, and install the dependencies in `requirements.txt` into the environment.
    * When the tutorial asks you to fill out the `wsgi` configuration file, paste the contents of the `wsgi.py` file included in this repo.

Note that this deploying web app requires a paid account on PythonAnywhere, because free accounts are restricted from accessing the open internet, which is required in order to query the Renku Knowledge Graph API.

## Project Structure
This repo contains the following files:
```
src/
    assets/  # css definition for the dashboard
    dash_app.py  # dashboard entry point, and defines the layout and interactivity of the dashboard
    knowledge_graph.py  # contains functions for querying the Renku Knowledge Graph API
requirements.txt  # project dependencies
wsgi.py  # sample file showing the wsgi configuration for deploying the webapp on PythonAnywhere
```
